////////////////////////////////////////////////////////////////
// Equivalent des fonctions de Turbo C
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////
#include <windows.h>
#include <stdio.h>
#include "coniowin32.h"

////////////////////////////////////////////////
// gotoxy() pour WIN32
////////////////////////////////////////////////
void gotoxy (int x,int y) 
{ 
    HANDLE hpos; 
    COORD coord; 
    coord.X=x-1; 
    coord.Y=y-1; 
    hpos=GetStdHandle (STD_OUTPUT_HANDLE ); 
    SetConsoleCursorPosition (hpos, coord ); 
} 

////////////////////////////////////////////////
// clrscr() pour WIN32
////////////////////////////////////////////////
void clrscr (void) 
{ 
    HANDLE hConsoleOut; 
    CONSOLE_SCREEN_BUFFER_INFO csbiInfo; 
    DWORD dummy; 
    COORD PointHautGauche = {0,0}; 
    
    hConsoleOut= GetStdHandle (STD_OUTPUT_HANDLE ); 
    GetConsoleScreenBufferInfo ( hConsoleOut , & csbiInfo ); 
    
    FillConsoleOutputCharacter ( hConsoleOut ,' ' ,csbiInfo.dwSize.X *  csbiInfo.dwSize.Y , PointHautGauche , &dummy );
    FillConsoleOutputAttribute( hConsoleOut ,csbiInfo.wAttributes ,csbiInfo.dwSize.X *  csbiInfo.dwSize.Y , PointHautGauche , &dummy );
}

////////////////////////////////////////////////
// _setcursortype() pour WIN32
////////////////////////////////////////////////
void _setcursortype( int cur_t )
{
    CONSOLE_CURSOR_INFO ConsoleCursorInfo;
    if( GetConsoleCursorInfo( GetStdHandle (STD_OUTPUT_HANDLE ), &ConsoleCursorInfo ) )
    {
	switch(cur_t)
	{
	case _NOCURSOR:
	    {
		ConsoleCursorInfo.bVisible = FALSE;
		break;
	    }
	case _SOLIDCURSOR:
	    {
		ConsoleCursorInfo.bVisible = TRUE;
		ConsoleCursorInfo.dwSize = 100;
		break;
	    }
	case _NORMALCURSOR:
	    {
		ConsoleCursorInfo.bVisible = TRUE;
		ConsoleCursorInfo.dwSize = 25;
		break;
	    }
	}
	SetConsoleCursorInfo( GetStdHandle (STD_OUTPUT_HANDLE ), &ConsoleCursorInfo );
    }
}

////////////////////////////////////////////////
// textmode() pour WIN32
////////////////////////////////////////////////
void textmode( int newmode )
{
    static COORD LastMode = { 80, 50 };
    static COORD dwSize = { 80, 50 };

    switch(newmode)
    {
    case LASTMODE:
	{
	    dwSize = LastMode;
	    break;
	}
    case BW40:
    case C40:
	{
	    LastMode = dwSize;
	    dwSize.X = 40;
	    dwSize.Y = 25;
	    break;
	}
    default:
    case BW80:
    case C80:
    case MONO:
	{
	    LastMode = dwSize;
	    dwSize.X = 80;
	    dwSize.Y = 25;
	    break;
	}
    case C4350:
	{
	    LastMode = dwSize;
	    dwSize.X = 80;
	    dwSize.Y = 50;
	    break;
	}
    }
    SetConsoleScreenBufferSize(  GetStdHandle (STD_OUTPUT_HANDLE ), dwSize );
}


////////////////////////////////////////////////
// Adaptation des couleurs Turbo C - Windows Console
////////////////////////////////////////////////
static WORD TurboCColor2BackgroundConsoleColor( int tccolor )
{
    WORD wcolor = tccolor;
    wcolor = (wcolor << 4);
    return wcolor;
}

////////////////////////////////////////////////
// textcolor() pour WIN32
////////////////////////////////////////////////
void textcolor( int newcolor )
{
    WORD wcolor = newcolor;
    CONSOLE_SCREEN_BUFFER_INFO ConsoleScreenBufferInfo;
    GetConsoleScreenBufferInfo( GetStdHandle(STD_OUTPUT_HANDLE ), &ConsoleScreenBufferInfo );

    wcolor = wcolor + (ConsoleScreenBufferInfo.wAttributes & 0xFFF0);
    SetConsoleTextAttribute( GetStdHandle(STD_OUTPUT_HANDLE ), wcolor );
}

////////////////////////////////////////////////
// textbackground() pour WIN32
////////////////////////////////////////////////
void textbackground( int newcolor )
{
    WORD wcolor;
    CONSOLE_SCREEN_BUFFER_INFO ConsoleScreenBufferInfo;
    GetConsoleScreenBufferInfo( GetStdHandle(STD_OUTPUT_HANDLE ), &ConsoleScreenBufferInfo );

    wcolor = TurboCColor2BackgroundConsoleColor( newcolor );

    wcolor = wcolor + (ConsoleScreenBufferInfo.wAttributes & 0xFF0F);
    SetConsoleTextAttribute( GetStdHandle(STD_OUTPUT_HANDLE ), wcolor );
}

////////////////////////////////////////////////
// window() pour WIN32
////////////////////////////////////////////////
void window( int left, int top, int right, int bottom )
{
    // Non supporte
//    MessageBox( NULL, "Fonction non supporte", "ATTENTION", MB_ICONEXCLAMATION );
}

////////////////////////////////////////////////
// gettext() pour WIN32
////////////////////////////////////////////////
int gettext( int left, int top, int right, int bottom, void * destin )
{
    BOOL fRet;
    COORD dwBufferSize;
    COORD dwBufferCoord;
    SMALL_RECT Region;

    dwBufferSize.X = right - left + 1;
    dwBufferSize.Y = bottom - top + 1;

    dwBufferCoord.X = 0;//left - 1;
    dwBufferCoord.Y = 0;//top - 1;

    Region.Left = left - 1;
    Region.Top = top - 1;
    Region.Right = right - 1;
    Region.Bottom = bottom - 1;
    
    fRet = ReadConsoleOutput( GetStdHandle(STD_OUTPUT_HANDLE ), 
	(PCHAR_INFO )destin, dwBufferSize, dwBufferCoord, &Region );

    return fRet;
}

////////////////////////////////////////////////
// puttext() pour WIN32
////////////////////////////////////////////////
int puttext( int left, int top, int right, int bottom, void * source )
{
    BOOL fRet;
    COORD dwBufferSize;
    COORD dwBufferCoord;
    SMALL_RECT Region;

    dwBufferSize.X = right - left + 1;
    dwBufferSize.Y = bottom - top + 1;

    dwBufferCoord.X = 0;//left - 1;
    dwBufferCoord.Y = 0;//top - 1;

    Region.Left = left - 1;
    Region.Top = top - 1;
    Region.Right = right - 1;
    Region.Bottom = bottom - 1;
    
    fRet = WriteConsoleOutput( GetStdHandle(STD_OUTPUT_HANDLE ), 
	(PCHAR_INFO )source, dwBufferSize, dwBufferCoord, &Region );

    return fRet;
}

// VC2005 : putch() et _putch() ne marchent pas bien (Unicode?)
int putch2( int c )
{
    printf( "%c", c );
    return c;
}
