#ifndef CONIOWIN32_H
#define CONIOWIN32_H

#ifdef __cplusplus
extern "C" {
#endif

#include <windows.h>

#define _NOCURSOR	0
#define _SOLIDCURSOR	1
#define _NORMALCURSOR   2

#define BLACK           0
#define BLUE            FOREGROUND_BLUE
#define GREEN           FOREGROUND_GREEN
#define CYAN            FOREGROUND_GREEN | FOREGROUND_BLUE
#define RED             FOREGROUND_RED
#define MAGENTA         FOREGROUND_RED    | FOREGROUND_BLUE
#define BROWN           FOREGROUND_RED    | FOREGROUND_GREEN
#define LIGHTGRAY       FOREGROUND_RED    | FOREGROUND_GREEN | FOREGROUND_BLUE
#define DARKGRAY        FOREGROUND_INTENSITY
#define LIGHTBLUE       FOREGROUND_BLUE  | FOREGROUND_INTENSITY
#define LIGHTGREEN      FOREGROUND_GREEN | FOREGROUND_INTENSITY
#define LIGHTCYAN       FOREGROUND_GREEN | FOREGROUND_BLUE   | FOREGROUND_INTENSITY
#define LIGHTRED        FOREGROUND_RED     | FOREGROUND_INTENSITY
#define LIGHTMAGENTA    FOREGROUND_RED     | FOREGROUND_BLUE  | FOREGROUND_INTENSITY
#define YELLOW          FOREGROUND_RED     | FOREGROUND_GREEN | FOREGROUND_INTENSITY
#define WHITE		FOREGROUND_RED    | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY
 
#define LASTMODE	-1
#define BW40		0
#define C40		1
#define BW80		2
#define C80		3
#define MONO		7
#define C4350		64


void gotoxy( int x, int y );
void clrscr (void);
void _setcursortype( int cur_t );
void textmode( int newmode );
void textattr( int newattr );
void textcolor( int newcolor );
void textbackground( int newcolor );
int gettext( int left, int top, int right, int bottom, void * destin );
int puttext( int left, int top, int right, int bottom, void * source );
int putch2( int c );

#ifdef __cplusplus
}
#endif

#endif	//CONIOWIN32_H
