#ifndef PAC_CORE_H
#define PAC_CORE_H

#include <time.h>

/**
 * Types de piece
 */
#define PAC_TYPE_NOTHING                0   /*0x20*/
#define PAC_TYPE_WALL_VERT              1   /*0xDB*/
#define PAC_TYPE_WALL_HORIZ             2   /*0xDB*/
#define PAC_TYPE_WALL_TOP_LEFT          3   /*0xDB*/
#define PAC_TYPE_WALL_TOP_RIGHT         4   /*0xDB*/
#define PAC_TYPE_WALL_BOTTOM_LEFT       5   /*0xDB*/
#define PAC_TYPE_WALL_BOTTOM_RIGHT      6   /*0xDB*/
#define PAC_TYPE_PACMAN                 7   /*'O'*/
#define PAC_TYPE_MONSTER                8   /*'A'*/
#define PAC_TYPE_FRUIT                  9
#define PAC_TYPE_MAGIC_FRUIT            10

void load_game( const char * gameFile );
void set_level( int level, time_t timePacEater, time_t timeRecreateMonster, int nbLifes );
void move_monsters();
void move_pacman();
void go_left();
void go_right();
void go_top();
void go_bottom();
int is_game_over();
int is_level_won();
int get_score();
int get_level();
int get_lifes();
void repaint();
int get_x_size();
int get_y_size();


#endif //PAC_CORE_H
